#if 1
#include <ctype.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>

#include <opencv2/highgui/highgui.hpp>  // OpenCV window I/O
#include <opencv2/imgproc/imgproc.hpp>  // Gaussian Blur

#include "card_type.h"
#include "tdr_ocr.h"
#include "tdrocr.h"
#include "utils.h"

using namespace std;
using namespace cv;

bool isDebugShow();
void setDebugShow(int debug);
void get_extension(const char *file_name, char *extension);
int check_ocr_by_read_ocr_info(OCR_RESULT &ocr_result);
int append_valid_region_file(char *filename, char *flag_value);

extern cv::Mat g_rapidRec_line_1;
extern cv::Mat g_rapidRec_line_2;

int get_last_subdir(const char *file_name, char *subdir) {
  int found_first = -1;
  int i;
  for (i = strlen(file_name) - 1; i >= 0; i--) {
    if (file_name[i] == '/') {
      found_first = i;
      break;
    }
  }

  if (found_first <= 0) return -1;
  found_first--;

  int found_second = 0;
  for (i = found_first; i >= 0; i--) {
    if (file_name[i] == '/') {
      found_second = i + 1;
      break;
    }
  }

  int len = found_first - found_second + 1;
  memcpy(subdir, &file_name[found_second], len);
  subdir[len] = 0x00;
  return len;
}

void get_valid_char_img(cv::Mat &src, std::vector<cv::Rect> roi_rect_list,
                        int line, OCR_RESULT &ocr_result, char *filename) {
  int len = strlen(filename);
  char name[200];
  char dirname[200];
  char outputdir[200];
  char outputdir_head[200];
  char file_name[200];
  char convert_char[10];
  const char *convert_AA = "AA";
  char flag_value[200];
  int first = 0;
  int first_end = 0;
  int name_len = 0;
  int ext_cnt = 0;

  if (line == 2) ext_cnt = 44;

  for (int i = 0; i < len; i++) {
    if (filename[len - i - 1] == '.') {
      first_end = len - i - 1;
      break;
    }
  }
  int i = 0;
  for (; i < first_end; i++) {
    if (filename[len - i - 1] == '/') {
      first = len - i - 1;
      name_len = first_end - first - 1;
      memcpy(name, &filename[first + 1], name_len);
      memcpy(file_name, &filename[first + 1], name_len);
      file_name[name_len] = 0x00;
      break;
    }
  }
  if (i == first_end) {
    name_len = first_end;
    memcpy(name, &filename[0], name_len);
    memcpy(file_name, &filename[0], name_len);
    file_name[name_len] = 0x00;
  }

  // 添加行号
  name[name_len++] = '_';
  sprintf(name + name_len++, "%d", line);
  // 添加序号位置
  name[name_len++] = '_';
  int name_order_pos = name_len;

  DIR *mydir;
  sprintf(outputdir_head, "gen_data");
  if ((mydir = opendir(outputdir_head)) == NULL)
    mkdir(outputdir_head, S_IRWXU | S_IRWXG | S_IRWXO);
  else
    closedir(mydir);

  RNG rng(time(0));

  int aa_count = 0;
  int edge1 = rng.uniform(0, 8);
  int edge2 = rng.uniform(0, 8);
  int edge3 = rng.uniform(0, 8);
  int edge4 = rng.uniform(0, 8);

  // 添加序号值并存图
  for (int i = 0; i < roi_rect_list.size(); i++) {
    Mat tmp_img = src(roi_rect_list[i]);
    CvRect crop_rect =
        cropCharRect(roi_rect_list, roi_rect_list.size(), i, i, src.cols,
                     src.rows, edge1, edge2, edge3, edge4);

    sprintf(name + name_order_pos, "%02d", i + ext_cnt);

    char cur_char_value = ocr_result.mrz[i + ext_cnt];
    // sprintf(outputdir, "validCharImg/%c",cur_char_value);
    if (cur_char_value == '<') {
      if (aa_count % 4 != 0) {
        aa_count++;
        continue;
      }
      aa_count++;
    }

    memset(convert_char, 0, sizeof(convert_char));
    if (cur_char_value != '<')
      sprintf(convert_char, "%c", cur_char_value);
    else
      sprintf(convert_char, "%s", convert_AA);

    strcpy(outputdir, outputdir_head);
    strcat(outputdir, "/");
    strcat(outputdir, convert_char);

    outputdir[strlen(outputdir)] = 0x00;
    if ((mydir = opendir(outputdir)) == NULL)
      mkdir(outputdir, S_IRWXU | S_IRWXG | S_IRWXO);
    else
      closedir(mydir);

    strcat(outputdir, "/");
    strcat(outputdir, name);
    // 添加后缀
    strcat(outputdir, ".jpg");
    // printf("%s\n", outputdir);

    int resize_x = (float)tmp_img.cols / (float)tmp_img.rows * 48;
    int resize_y = 48;
    cv::resize(tmp_img, tmp_img, cv::Size(resize_x, resize_y), 0,
               0);  //, INTER_NEAREST);

    imwrite(outputdir, tmp_img);

    // 增加一个标签文件，格式 文件名\t标签 例： A/xxx.jpg\tA B/xxx.jpg\tB

    const char *flag_file_name = "label.txt";
    memset(flag_value, 0, sizeof(flag_value));

    strcat(flag_value, convert_char);
    strcat(flag_value, "/");
    strcat(flag_value, name);
    strcat(flag_value, ".jpg");
    strcat(flag_value, "\t");
    int len = strlen(flag_value);
    flag_value[len] = cur_char_value;
    flag_value[len + 1] = 0x00;
    append_valid_region_file((char *)flag_file_name, flag_value);
  }
}

int append_valid_region_file(char *filename, char *flag_value) {
  FILE *fp;
  if ((fp = fopen(filename, "a")) == NULL) {
    printf("write result file error!");
    return -1;
  }

  fputs(flag_value, fp);
  fputs("\n", fp);
  fclose(fp);
  return 0;
}

void get_valid_region_img(cv::Mat &src1, std::vector<cv::Rect> roi_rect_list1,
                          cv::Mat &src2, std::vector<cv::Rect> roi_rect_list2,
                          OCR_RESULT &ocr_result, char *filename) {
  RNG rng(time(0));
  int total = roi_rect_list1.size();

  for (int repeat = 0; repeat < 200; repeat++) {
    int valid_line = rng.uniform(10, 25);
    if (isDebugShow()) printf("valid_line=%d.\n", valid_line);
    int valid_len = rng.uniform(2, 16);  // 44);
    int valid_pos = rng.uniform(0, total - valid_len);

    valid_line = valid_line % 2 + 1;

    if (isDebugShow())
      printf("valid_line=%d,valid_pos=%d,valid_len=%d.\n", valid_line,
             valid_pos, valid_len);
    int len = strlen(filename);
    char name[200];
    char dirname[200];
    char outputdir[200];
    char flag_value[200];
    int first = 0;
    int first_end = 0;
    int name_len = 0;

    for (int i = 0; i < len; i++) {
      if (filename[len - i - 1] == '.') {
        first_end = len - i - 1;
        break;
      }
    }
    int i = 0;
    for (; i < first_end; i++) {
      if (filename[len - i - 1] == '/') {
        first = len - i - 1;
        name_len = first_end - first - 1;
        memcpy(name, &filename[first + 1], name_len);
        break;
      }
    }
    if (i == first_end) {
      name_len = first_end;
      memcpy(name, &filename[0], name_len);
    }

    // 添加行号
    name[name_len++] = '_';
    sprintf(name + name_len++, "%d", valid_line);
    // 添加起始位置
    name[name_len++] = '_';
    sprintf(name + name_len, "%02d", valid_pos);
    name_len += 2;
    // 添加长度
    name[name_len++] = '_';
    sprintf(name + name_len, "%02d", valid_len);
    name_len += 2;
    name[name_len] = 0x00;
    // 存图
    DIR *mydir;
    sprintf(outputdir, "gen_data/BB");
    if ((mydir = opendir(outputdir)) == NULL)
      mkdir(outputdir, S_IRWXU | S_IRWXG | S_IRWXO);
    else
      closedir(mydir);

    Rect tmp;
    Mat tmp_img;
    int edge1 = rng.uniform(0, 8);
    int edge2 = rng.uniform(0, 8);
    int edge3 = rng.uniform(0, 8);
    int edge4 = rng.uniform(0, 8);

    if (valid_line == 1) {
      CvRect crop_rect =
          cropCharRect(roi_rect_list1, roi_rect_list1.size(), valid_pos,
                       valid_pos + valid_len - 1, src1.cols, src1.rows, edge1,
                       edge2, edge3, edge4);
      tmp_img = src1(crop_rect);

    } else {
      CvRect crop_rect =
          cropCharRect(roi_rect_list2, roi_rect_list2.size(), valid_pos,
                       valid_pos + valid_len - 1, src2.cols, src2.rows, edge1,
                       edge2, edge3, edge4);
      tmp_img = src2(crop_rect);
    }

    strcat(outputdir, "/");
    strcat(outputdir, name);

    // 添加后缀
    strcat(outputdir, ".jpg");

    int resize_x = (float)tmp_img.cols / (float)tmp_img.rows * 48;
    int resize_y = 48;
    cv::resize(tmp_img, tmp_img, cv::Size(resize_x, resize_y), 0,
               0);  //, INTER_NEAREST);
    // printf("%s\n", outputdir);
    imwrite(outputdir, tmp_img);

    const char *flag_file_name = "label.txt";
    strcpy(flag_value, "BB/");
    strcat(flag_value, name);
    strcat(flag_value, ".jpg");
    strcat(flag_value, "\t");
    int flag_value_len = strlen(flag_value);

    // for(int n=0; n<88; n++){
    // printf("ocr_result.mrz[n]=%c.\n",ocr_result.mrz[n]);
    //}
    memcpy(flag_value + flag_value_len,
           ocr_result.mrz + valid_pos + (valid_line - 1) * 44, valid_len);
    flag_value[flag_value_len + valid_len] = 0x00;
    if (isDebugShow()) printf("%s\n", flag_value);
    append_valid_region_file((char *)flag_file_name, flag_value);
  }
}

#endif
