#ifndef __CARD_TYPE_INCLUDE
#define  __CARD_TYPE_INCLUDE

#include <string>
#include <opencv2/core.hpp>

typedef struct OCR_RESULT
{
    int valid;
    int certificate_type;   //证件类型 内部定义
    char certificate_name[48]; //证件名称(中文)
    char id[32];         //证件号码
    char name[40];       //中文姓名32
    char name_en[40];    //英文姓名32
    char nationality[32];//国籍
    char ethnicity[16];  //民族
    char address[64];    //住址
    char birthday[32];   //xxxxxxxx
    char birth_at[32];   //出生地
    char sex[8];        //中文
    char valid_from[16]; //xxxxxxxx
    char valid_to[16];   //xxxxxxxx
    char issue_date[16]; //xxxxxxxx
    char issue_by[32];   //发证机关
    char issue_at[32];   //签发地
    char issue_country[32]; //签发国(中文)
    char issue_count[16]; //签发次数
    char add_id[32];   //右上角的证件号
    char category[32];  //签证种类

    char mrz[100]; //机读区

    int icao_type;

    bool birth_ok;
    bool expDate_ok;
    bool ID_ok;
    bool cntry_ok;
    bool cntry1_ok;
    bool sex_ok;
    bool seleData_ok;
    bool addID_ok;
    int verify; //mrz verify 0=ok 

    //cv::Mat cropimg;
    //cv::Mat faceimg;

}OCR_RESULT;

typedef enum CERTIFICATE_TYPE{
      CERTIFICATE_TYPE_DEFAULT,  //0
      CERTIFICATE_TYPE_PASSPORT, //1
      CERTIFICATE_TYPE_ID,       //2
      CERTIFICATE_TYPE_FROM_HM,  //3
      CERTIFICATE_TYPE_FROM_TW,  //4
      CERTIFICATE_TYPE_TO_HM,    //5
      CERTIFICATE_TYPE_TO_TW,     //6
      CERTIFICATE_TYPE_VISA,     //7
      CERTIFICATE_TYPE_RESIDENT,  //8
      CERTIFICATE_TYPE_SEAFARER,   //9
      CERTIFICATE_TYPE_ENTRY_EXIT_PERMIT, //10
      CERTIFICATE_TYPE_APEC, //11
      CERTIFICATE_TYPE_FROM_TW_ONEOFF, //12
}CERTIFICATE_TYPE;

typedef enum ICAO_TYPE{
      ICAO_TYPE_DEFAULT=0,
      ICAO_TYPE_MRVA=1,
      ICAO_TYPE_MRVB=2
}ICAO_TYPE;

#endif

