/*
 * Copyright 2010, Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef TESSERACT_JNI_COMMON_H
#define TESSERACT_JNI_COMMON_H


/*
#define LOG_TAG "Tesseract(native)"
#define LOGV(...) __android_log_print(ANDROID_LOG_VERBOSE, LOG_TAG, __VA_ARGS__)
#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG, LOG_TAG, __VA_ARGS__)
#define LOGI(...) __android_log_print(ANDROID_LOG_INFO, LOG_TAG, __VA_ARGS__)
#define LOGW(...) __android_log_print(ANDROID_LOG_WARN, LOG_TAG, __VA_ARGS__)
#define LOGE(...) __android_log_print(ANDROID_LOG_ERROR, LOG_TAG, __VA_ARGS__)
*/

#define CARD_AI 1
#define SUPPORT_VISA 1
#define USE_VISA_NO 1
#define USE_VISA_CATEGORY 1
//#define NO_JUDGE_CARD_POSITION 1
//#define REMOVE_SIGNAL_LINE 1
//#define DSUPPORT_TEST_CTL 1
//#define CLOSE_SKIN 1

#ifdef ANDROID_PLATFORM
    #include <jni.h>
    #include <android/log.h>
    #include <assert.h>
    void tdr_log_android(int alway, int prio, const char *tag,  const char* format, ...);
#else
    void tdr_log(int alway, const char* format, ...);

    #include <sys/time.h>
    #include <unistd.h>
    #include <stdio.h>
    #include <stdarg.h>
    #include <string.h>
#endif

extern int CHAR_TEMPLATE_WIDTH;
extern int CHAR_TEMPLATE_HEIGHT;
extern int  CUT_SIZE;

#define OCR_TAG "[TDROCR]"
//#define ANDROID_PLATFORM
#define NEW_LOCATION 1

#ifdef ANDROID_PLATFORM
       //#define LOGD(...) ((void)__android_log_print(ANDROID_LOG_DEBUG, OCR_TAG,fmt, ##__VA_ARGS__))
       #define LOGD(fmt, ...) (tdr_log_android(0, ANDROID_LOG_DEBUG, OCR_TAG,fmt, ##__VA_ARGS__))
       #define LOGI(fmt, ...) (tdr_log_android(1, ANDROID_LOG_DEBUG, OCR_TAG,fmt, ##__VA_ARGS__))
       //#define LOGI(...) ((void)__android_log_print(ANDROID_LOG_INFO, OCR_TAG, __VA_ARGS__))
       #define LOGW(...) ((void)__android_log_print(ANDROID_LOG_WARN, OCR_TAG, __VA_ARGS__))
       #define LOGE(...) ((void)__android_log_print(ANDROID_LOG_ERROR, OCR_TAG, __VA_ARGS__))
       #define LOG_ASSERT(_cond, ...) if (!_cond) __android_log_assert("conditional", OCR_TAG, __VA_ARGS__)
#else
       //#define LOGD(fmt, ...) (tdr_log(fmt, ##__VA_ARGS__))
       #define LOGD(fmt, ...) (tdr_log(0, fmt, ##__VA_ARGS__))
       #define LOGI(fmt, ...) (tdr_log(1, fmt, ##__VA_ARGS__))
       //#define LOGI(fmt, ...) printf(fmt, ##__VA_ARGS__);printf("\n")
       #define LOGW(fmt, ...) printf(fmt, ##__VA_ARGS__);printf("\n")
       #define LOGE(fmt, ...) printf(fmt, ##__VA_ARGS__);printf("\n")
#endif


#endif
