#ifndef __PASSPORT_VISA
#define __PASSPORT_VISA
#include <opencv2/opencv.hpp>

#define SUPPORT_VISA

#ifdef SUPPORT_VISA
//#define USE_ISSUER_ADDR
#define USE_VISA_NO
#define USE_VISA_CATEGORY


typedef enum SCAN_ITEM{
     SCAN_ITEM_LOC=0,    //需要定位项目的类型
     SCAN_ITEM_CATEGORY, //签证种类
     SCAN_ITEM_ICAO,
     SCAN_ITEM_START_X,
     SCAN_ITEM_END_X,
     SCAN_ITEM_BASE_Y,
     SCAN_ITEM_START_Y,
     SCAN_ITEM_END_Y,
     SCAN_ITEM_SCALE_X,
     SCAN_ITEM_MINW,   //文本框的最小宽度
     SCAN_ITEM_MINH,   //文本框的最小高度
     SCAN_ITEM_FILTER  //从多个文本框中选取一个的方式，
}SCAN_ITEM;

typedef enum VISA_CATEGORY{
     VISA_CATEGORY_V=0,
     VISA_CATEGORY_VX=1,
}VISA_CATEGORY;


//#define TEST_PASSPORT 
#ifdef TEST_PASSPORT
#define VISA_NO_CNT    (9)
#else
#define VISA_NO_CNT    (8)
#endif

#define PASSPORT_NO_CNT    (9)
#define VISA_NO_EXT_CNT    (9)

#define DEFAULT_VALUE        (0xFFFFFFFF)
#define Hash_Table_Max_Size  (512)


typedef struct HASH_TABLE_STRUCT {
  unsigned int hash_table[Hash_Table_Max_Size];
  int hash_tbl_idx;
} HASH_TABLE_STRUCT;

extern HASH_TABLE_STRUCT hash_tbl_struct;

extern std::vector<cv::Point> g_point_list;


extern void clearVisaIssueInfo();

#ifdef USE_ISSUER_ADDR
extern int initVisaIssueInfo(char* path);

extern int load_city_dict(char * dir);
extern int check_cityList (char *item_name, HASH_TABLE_STRUCT *hash_tbl_str, int* pos_idx) ;
#endif

#define VISA_DISPLAY 
//#define VISA_TRACE
     #ifdef VISA_TRACE
     extern cv::Mat g_visa_category_cut_1;
     extern cv::Mat g_visa_category_cut_2;
     extern cv::Mat g_visa_category_detect;

     extern cv::Mat g_vis_no_cut;
     extern cv::Mat g_vis_no_color;
     extern void init_visa_test();
     extern void recordFile(char *filename, char* recordDir, char* typeName, cv::Mat img) ;
     #endif 

#endif

#endif
