#include <sys/time.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <vector>
#include <map>
#include <opencv2/imgproc/imgproc.hpp>  // Gaussian Blur
#include <opencv2/core/core.hpp>        // Basic OpenCV structures (cv::Mat, Scalar)
#include <opencv2/videoio/videoio.hpp>
#include <opencv2/highgui/highgui.hpp>  // OpenCV window I/O
#include <opencv2/features2d/features2d.hpp>
#include <opencv2/objdetect/objdetect.hpp>
#include <omp.h>
#include "verify.h"
#include "common.h"
#include "tdr_crnn.h"
#include "matchocr.h"
#include "tdrocr.h"
#include "card_type.h"

extern cv::Mat g_rapidRec_line_1;
extern cv::Mat g_rapidRec_line_2;
extern cv::Mat g_rapidRec_line_3;

using namespace cv;
using namespace std;

extern PASSPORT_OCR_RESULT   passport_ocr_result;
extern PASSPORT_OCR_RESULT   passport_ocr_result_saved;
//可信度
extern int             ocr_mean_conf ;
extern int             ocr_min_conf ;
extern int             ocr_min_conf1;
extern int             pos_min_conf ;
extern int             pos_min_conf1;
extern int             ocr_sum_conf ;

#define BIRTHDAY_OFFSET 58
#define EXPIREDDAY_OFFSET  66
#define NCODE_OFFSET 55
#define NCODE1_OFFSET 3
#define SEX_OFFSET  65
#define SELECT_OFFSET 73
#define ID_OFFSET  45
#define FINAL_OFFSET  88

void clearResult();
void clearCardResult();
void clearOcrResult(OCR_RESULT & ocr_result);
int copy_ocr_result(PASSPORT_OCR_RESULT &src, OCR_RESULT & ocr_result);
void print_passport_result(OCR_RESULT &result);
int copy_ocr_result(OCR_RESULT &src, OCR_RESULT & ocr_result);
int copy_passport_result(PASSPORT_OCR_RESULT &src, PASSPORT_OCR_RESULT & dst);
