#include "OcrStruct.h"

#ifndef __CRNN_EXTRACT_H_
#define __CRNN_EXTRACT_H_

typedef enum TEXT_BOX_FILTER_TYPE{
      TEXT_BOX_FILTER_WIDTH=0,
      TEXT_BOX_FILTER_HEIGHT=1,
      TEXT_BOX_FILTER_AREA=2
}TEXT_BOX_FILTER_TYPE;

typedef enum SCAN_LOCATION{
      VISA_ISSUE_NO_RIGHT_MID=0,
      VISA_ISSUE_NO_RIGHT_TOP=VISA_ISSUE_NO_RIGHT_MID+1,
      VISA_ISSUE_CATEGORY_LEFT=VISA_ISSUE_NO_RIGHT_TOP+1,
      VISA_ISSUE_CATEGORY_MID=VISA_ISSUE_CATEGORY_LEFT+1,
      VISA_PASSPORT_NO=VISA_ISSUE_CATEGORY_MID+1,
}SCAN_LOCATION;

// 当前版本去掉VISA_PASSPORT_NO类型的识别，为最小改动，枚举中保留定义，但实际不使用
#define SCAN_LOCATION_SIZE (4)

int init_crnn(char * model_dir, int model_opt);
TextLine  crnn_extract(cv::Mat src);
TextLine  crnn_extract_en(cv::Mat src, char format);  //format: 'O'字母数字 'N'数字 ‘L‘字母 'A'一个字母开头后跟数字 'B' 8位时全数字，9位时第一位为字母
TextLine  crnn_extract_en(cv::Mat src, char format, float threshold);  
TextLine  crnn_extract_en_v3(cv::Mat src, char format);  //format: 'O'字母数字 'N'数字 ‘L‘字母 'A'一个字母开头后跟数字 'B' 8位时全数字，9位时第一位为字母
TextLine  crnn_extract_cn(cv::Mat src);  //识别gb2312简体汉字
TextLine  crnn_extract_cn_date(cv::Mat src);  //识别gb2312简体汉字
TextLine  crnn_extract_gbk(cv::Mat src); //识别gbk简繁体汉字
TextLine  crnn_extract_mrz(cv::Mat src, char format); //识别mrz数字英文 format定义同crnn_extract_en
cv::Mat  crnn_detect_textbox(cv::Mat & src, int minWidth, int minHeight, TEXT_BOX_FILTER_TYPE filter, SCAN_LOCATION loc,  cv::RotatedRect & rotated_rect); //检测文本框
cv::Mat crnn_detect_textbox(cv::Mat & src, int minWidth, int minHeight);
void draw_text_boxs(const cv::Mat& img, std::vector<TextBox> &textBoxes, int idx, SCAN_LOCATION loc);
void draw_text_box(const cv::Mat& img, CvRect &box);


#endif
