#ifndef __TDROCR_INCLUDE
#define __TDROCR_INCLUDE
#include <vector>
#include <map>
#include <string>
#include <opencv2/imgproc/imgproc.hpp>  // Gaussian Blur
#include <opencv2/core/core.hpp>        // Basic OpenCV structures (cv::Mat, Scalar)
#include <opencv2/videoio/videoio.hpp>
#include <opencv2/highgui/highgui.hpp>  // OpenCV window I/O
#include <opencv2/features2d/features2d.hpp>
#include <opencv2/objdetect/objdetect.hpp>
#include "card_type.h"

using namespace std;
using namespace cv;

#define OCR_NUMBERS 88
#define OPTION_LEVEL_NUMBER 2
//4
#define FULLNAME_LENGTH 50
#define FULLNAME_NUMBER 15
#define GRAYCOLOR 200


typedef struct NEXT_FRAME
{
    int prev;
    int cur;
    float card_x;
    float card_y;
    float passport_x;
    float passport_y;
    int iscard;
}NEXT_FRAME;

typedef struct PASSPORT_OCR_RESULT
{
        int valid;
	char	result[OCR_NUMBERS+1];
	int	conf[OCR_NUMBERS+1];

	char	result_fullname[FULLNAME_LENGTH+1];
	int	conf_fullname[FULLNAME_LENGTH+1];
	//int	conf_fullname[FULLNAME_NUMBER+1];
        int     number_of_fullname;
    
	bool	ID_ok;
	char 	ID_result[11];

	bool	cntry_ok;
	char  	cntry_result[4];

        bool    cntry1_ok;
        char    cntry1_result[4];

	bool	birth_ok;
	char	birth_result[8];

	bool	sex_ok;
	char	sex_result[2];

	bool	expDate_ok;
	char	expDate_result[8];

	bool	seleData_ok;
	char	seleData_result[16];

        bool    head_ok;
        char    head_result[6];

        bool    issue_count_ok;
        char    issue_count_result[3];

        bool    add_id_ok;
        char    add_id_result[11];

	bool	final_verify_ok;
	char	final_verify_result[2];
        int     icao_type;

}PASSPORT_OCR_RESULT; 


extern vector<Rect>    g_posRect;
extern vector<Rect>    g_posRect1;
extern vector<Rect>    g_posRect2;
extern vector<Rect>    g_posRect3;

extern vector<Rect>    g_posRect1_rgb;
extern vector<Rect>    g_posRect2_rgb;
extern vector<Rect>    g_posRect3_rgb;

extern vector<Rect>    g_posRect_no_blank;
extern vector<Rect>    g_posRect3_no_blank;
//extern vector<Rect>    g_posRect_blank_1;
extern Mat g_line12;
extern Mat g_line12_2;
extern Mat rapidRec_line_1;
extern Mat rapidRec_line_2;
extern Mat rapidRec_line_3;
extern cv::Mat g_rapidRec_line_1;
extern cv::Mat g_rapidRec_line_2;
extern cv::Mat g_rapidRec_line_3;
extern NEXT_FRAME g_next_frame;

//初始化识别状态
extern bool            g_ocr_status;
extern PASSPORT_OCR_RESULT   passport_ocr_result;
//可信度
extern int             ocr_mean_conf;
extern int             ocr_min_conf;
extern int             ocr_min_conf1;
extern int             pos_min_conf ;
extern int             pos_min_conf1;
extern int             ocr_sum_conf;
extern int             ocr_conf[88];
extern int g_detect_mode;
extern int g_set_detect_mode;

extern int passportMatchOcr(vector<Rect> &posRect);
extern int passportMatchOcr2(cv::Mat & src, vector<Rect> &posRect, OCR_RESULT & ocr_result);
extern int passportCrnnOcr();
extern int passportCrnnOcr2();
extern int passport_location(cv::Mat& src, int &sz1, int & sz2);
extern int tdrocr_scan_yuv(unsigned char* data, int width, int height, int frm_wd, int frm_hg, int mode,  OCR_RESULT & ocr_result);
extern int tdrocr_scan_mat(cv::Mat& src, int mode,  OCR_RESULT & ocr_result);
extern void tdrocr_reset();


extern int  tdrocr_conf(int& sumConf, int& minConf, int& posMin);
extern void tdrocr_getResult(bool& status, string& result);
extern void tdrocr_unInit();
extern int tdrocr_init(const char* dir, const char* opt, int mode);
extern int init_card_ai(char * model_path);
void uninit_card_ai();



extern int fetchcharpos(const char * charformat, char * charpos, char chartype);
extern int charDtct(Mat& src, Mat& line1_tmp, Mat& line2_tmp, Mat& line1, Mat& line2);
extern void clearResult();
extern void clearCardResult();
extern unsigned char * getRectImage(int & len);
extern uint8_t* convert_Mat_to_BMP(Mat &img, int &bmp_size);

extern int imgRotate(Mat& img,float angle,float scale);
extern Point getPointAffinedPos(Point src,Point cer,float angle);
extern void getRectData(Mat src,int x0,int y0,int w,int h,float angle,Mat&dst);
extern void preprocess1(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2, int threshold1, int threshold2);
extern void preprocess_card(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2);
extern void preprocess_card_one(Mat& src1,Mat& dst1);
extern void preprocess2(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2);
extern void preprocess3(Mat src, Mat &dst);
extern void preprocess4(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2);
extern void preprocess5(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2);
extern int charseg(Mat &input, vector<Rect> &results);
extern int charseg0(Mat &input, vector<Rect> &results);
extern int process_ocr(const char * whitelist, const char * format, const char * chartype, int mode);
extern void BGR2NV21( unsigned char *imgSrc, unsigned char *imgDst, int width, int height );
extern void clearCharPos(char * charpos, int sz);
void tdr_set_log_file(const char * filename);
unsigned char * getFaceImage(unsigned char* src_data, int width, int height, int frm_wd, int frm_hg, int & len);
double tdr_get_current_time();  //unit is millisecond

extern int tdr_card_scan(Mat& src, OCR_RESULT & ocr_result);
extern int detect_card(Mat& src, Mat& card, bool& isfront, Rect& rectFace, int camera);
extern int detectLettersRect_new3(Mat& src, Rect rectFace,vector<Rect>& linesSelect, int cardClass, int camera);
extern int detectLettersRect_back(Mat& src, vector<Rect>& linesSelect, int camera);
//extern int rapid_det(Mat& src, Mat& dst, Rect& rectFace, Rect& detRect);


extern int rapidocr_front(Mat& src, vector<Rect>& lineRect, int cardClass, int camera);
extern int rapidocr_back(Mat& src, vector<Rect>& lineRect,int camera);

void showError(int no);
extern int getCardFaceImage(cv::Mat  &src, cv::Mat &dst, cv::Rect& rectFace);

typedef enum TDR_MODEL_TYPE{
    MODEL_TYPE_EN=0,
    MODEL_TYPE_MRZ,
    MODEL_TYPE_CN,
    MODEL_TYPE_GBK,
    MODEL_TYPE_EN_V3,
    MODEL_TYPE_MRZ_L
}TDR_MODEL_TYPE;

typedef enum TDR_OCR_ERROR{
      ERROR_OTR_NONE=-2,
      ERROR_OTR_ONE=-3,
      ERROR_CHAR_LENGTH_NOT_VALID=-4,
      ERROR_SAFE_RECT=-5,
      ERROR_ROTATION=-6,
      ERROR_IMAGE_SIZE= -7,

      ERROR_BIRTHDAY = -21,
      ERROR_EXPIRED_DATE = -22,
      ERROR_ID=-23,
      ERROR_LINE1=-24,
     
      ERROR_NCODE = -34,
      ERROR_SEX   = -35,
      ERROR_OPTION = -36,
      ERROR_FINAL =  -37,
      ERROR_ENAME = -38, 

      ERROR_VISA_PLACE_OF_ISSUE = -39,	  
      ERROR_VISA_PASSPORT_NO = -40,
      ERROR_VISA_NO_CONDITION = -41,
        
      ERROR_CITY_LIST_INPUT = -42,
      ERROR_CITY_LIST_HASH_TYPE = -43,
      ERROR_CITY_LIST_BEYOND = -44,
      ERROR_CITY_LIST_NO_EXIST_POS = -45,
      ERROR_CITY_LIST_NO_EXIST_VALUE = -46,
      ERROR_CITY_LIST_OUTPUT  = -47,
      ERROR_ISSUE_COUNT = -48,

      ERROR_BLUR = -60,
      ERROR_TPL  = -61,
      ERROR_SEG  = -62,
      ERROR_HEAD = -63,

      ERROR_POSRECT1 = -70,
      ERROR_POSRECT2 = -71,
  
      ERROR_NEXT = -80, 

      ERROR_LOCATION = -1001,
      ERROR_CARD_LOCATION = -1002,
      ERROR_DOC_TYPE = -1003,
      ERROR_MRZ_DETECT = -303
}TDR_OCR_ERROR;

typedef struct _myTextRect
{
        vector<Rect>            boundRect;
        vector<RotatedRect>     rotatedRect;
}myTextRect;

bool isDebugShow();
void setDebugShow(int debug);
void setDetectMode(int mode);
int getDetectMode(int mode);


typedef struct PASSPORT_ROTATED_STRUCT 
{
  cv::Rect_<float> rrect ;
  float roi_angle;
  bool im_valid;
  
  cv::Mat im; // 仿射变换 逆矩阵
  //int edge; //字符扫描之前的图有加边框的操作
  cv::Size after_affine_cut_diff; // 仿射变换后的图进行了裁剪 需要恢复原大小
  cv::Size before_affine_cut_diff; // 仿射变换前为了不丢失有效数据原图进行了扩展，需要推导有效数据原图位置
}PASSPORT_ROTATED_STRUCT; 


//#define SUPPORT_TEST_CTL
#ifdef SUPPORT_TEST_CTL
extern void clear_rotate_status();
extern void set_rotate_status();
extern int check_rotate_status();
extern void init_test_info_item();
extern int append_test_info_item(char *flag_name, int flag_value) ;
extern void write_test_info(char *filename) ;
#define NO_TEST_PARA 0xEEFFFFFF
#endif

//#define NO_JUDGE_CARD_POSITION

#define SPPORT_MRZ_CHECK
#endif
