#ifndef __UTILS__H
#define __UTILS__H

#include <opencv2/opencv.hpp>

#include <vector>
#include <cmath>
using namespace cv;
using namespace std;
enum {
LINE_NUMBER_1=1,
LINE_NUMBER_2=2,
LINE_NUMBER_3=3,
};

bool compContours(vector<cv::Point> cont1, vector<cv::Point >cont2);
bool comp(RotatedRect a, RotatedRect b);
bool comp_x(cv::Rect a, cv::Rect b);
bool comp_y(cv::Rect a, cv::Rect b);
bool comp_area(RotatedRect a, RotatedRect b);
bool comp_area_2(Rect a, Rect b );
bool compoint_x(Point a, Point b);
bool compoint_y(Point a, Point b);
bool comp_rotcenter(RotatedRect a, RotatedRect b);
Point2f getPointAffinedPos(Point2f src, Point2f center, float angle_ori);
int imgRotate(Mat& img,float angle,float scale);
int imgRotate_2(Mat& src, Mat& card, Rect_<float>& safeBoundRct, RotatedRect& roi_rect, int scale);
bool calcSafeRect(const RotatedRect& roi_rect, const Mat& src, Rect_<float>& safeBoundRect);
bool rotation(Mat& in, Mat& out, Size rect_size, Point2f center, const double angle);
cv::Mat cropRotateRect(Mat & in, RotatedRect & rr);
void SkinDetect(Mat& src, Mat& skinMask);
int mergeCols(cv::Mat A, cv::Mat B, cv::Mat &C);
bool vertical(Point a, Point b, Point c);
bool vertical2(Point a, Point b, Point c, Point d);
bool vertical2_wx(Point a, Point b, Point c, Point d);
bool vertical_dj(Point a, Point b, Point c, Point d);
bool vertical3(Point a, Point b, Point c);
bool vertical3_wx(Point a, Point b, Point c);
int pointLen(Point a, Point b);
cv::Point CircleCross(cv::Point point1, cv::Point point2,cv::Point cross1, cv::Point cross2,cv::Point& cross,int card_w, int card_h);
cv::Point CrossPoint(cv::Point point1, cv::Point point2, cv::Point point3, cv::Point point4);
Mat convertTo3Channels(const Mat& binImg);
int highlightDet(Mat& src, Mat& dst);
double calc_dist(cv::Point2f pt1, cv::Point2f pt2, cv::Point2f pt3);
int cornerDirect(Point c1, Point p1, Point c2, Point p2);
double lineAngle(Point p1, Point P2, Point c);
void showLineRect(cv::Mat & line, vector<Rect> & pos_rect, char * title);

//判断前后帧是否是同一护照
int  checkTheSamePassport();
int verifyLine1(char * data1, char * data2, int number);
void fixLine1(char * data1, char * data2, int number);

CvRect  cropCharRect(vector<Rect> pos, int total,  int from, int to, int width, int height, int left, int right, int top, int bottom);
void set_force_ai(int force);
bool correctPassportid_o0(char mrz[], char modify[], Mat &src, vector<Rect> &posRect, int startIndex = 44, int str_len = 9);
int isMoved(int iscard, float x, float y);
#endif
