
  
  #include <opencv2/opencv.hpp>
  #include <iostream>
  #include "common.h"
  #include <omp.h>
  #include "tdrocr.h"
  #include "utils.h"
  #include <stdio.h>
  #include "passport_visa.h"
  #include "OcrStruct.h" 
  #include "tdr_crnn.h"
  
#ifdef SUPPORT_VISA 

extern PASSPORT_ROTATED_STRUCT g_rotated_struct[];
PASSPORT_ROTATED_STRUCT g_get_issue_addr;

vector<Point> g_point_list;
void check_dispaly(cv::Mat& src, cv::Mat& roi, float r, int scan_item);
void clearVisaIssueInfo();
int initVisaIssueInfo(char* path);
void get_valid_point(Point2f* pt, Size size);
void get_valid_rect(Rect* rect, Size size);
void get_roi_map_point(Point2f pt_src, Point2f* pt_dst, float r);
void get_src_map_point(Point2f pt_src, Point2f* pt_dst, int src_high_offset, float mat_length, Size size);
bool checkVisaText(TextLine *text_line , int scan_item);
bool checkVisaNo_Ext(TextLine *text_line );
int scanVisaNo(cv::Mat & box_mat, TextLine & text, int scan_item);
int scan_category(cv::Mat & box_mat, TextLine & text);
int scanVisaNo_Ext(cv::Mat & box_mat, TextLine & text);
extern int g_aCharWidth;
extern int g_aCharHeight;

//定义需要扫描识别的栏目              // 0                   1    ,    2    3      4    5     6     7      8    9   10    11
int scan_item_location[][12]={        // loc        VISA_CATEGORY,  icao,startx,endx,basey,starty,endy,scalex,miniW,minH, filter
                                 //{ VISA_ISSUE_ADDR, VISA_CATEGORY_V,   0,    20,  34,   20,    35,  30,    0,   2,   1, TEXT_BOX_FILTER_HEIGHT},
                                 //{ VISA_ISSUE_ADDR, VISA_CATEGORY_V,   1,    25,  36,   25,    35,  31,   20,   2,   1, TEXT_BOX_FILTER_HEIGHT },
  								               // 此两项必须在上面，后面两项根据其来决定执行哪个
                                 { VISA_ISSUE_NO_RIGHT_MID, VISA_CATEGORY_V, 0, 36, 44, 6, 11, 7, 50, 5, 1,TEXT_BOX_FILTER_WIDTH},
                                 { VISA_ISSUE_NO_RIGHT_TOP, VISA_CATEGORY_V,   0,    29,  44,    6,    32,  26,   50,   5,   1, TEXT_BOX_FILTER_WIDTH },

                                 { VISA_ISSUE_CATEGORY_MID, VISA_CATEGORY_V, 0, 12, 16, 4, 20, 23, 0, 1, 1,TEXT_BOX_FILTER_HEIGHT},
                                 { VISA_ISSUE_CATEGORY_LEFT, VISA_CATEGORY_V, 0, 5, 13, 4, 21, 24, 0, 1, 1,TEXT_BOX_FILTER_HEIGHT},
                                 // 此项是遗留项，是否保留？？
                                 // 不支持暂时去掉。注意其机读区第二行，在‘<’中插入其他有效字符
                                // { VISA_PASSPORT_NO,VISA_CATEGORY_V,   1,    25,  36,    7,    23,  19,   20,   4,   1, TEXT_BOX_FILTER_WIDTH }
                            };  


#ifdef USE_ISSUER_ADDR
int initVisaIssueInfo(char* path)
{
  char city_list_path[100];
  const char * file_name = "city.txt";
  strcpy(city_list_path, path);
  strcat(city_list_path, "/");
  strcat(city_list_path, file_name);
  clearVisaIssueInfo();
  int rsp = load_city_dict(city_list_path);
  LOGD("load_city_dict [%s] %s", city_list_path, rsp==0? "ok":"fail");
  return rsp;
}
#endif


enum {
  RED_RECT_1 = 0,
  RED_RECT_2 = RED_RECT_1 + 1
} COLOR_REGION;

#define COND_SPLIT_NUMBER 2

int ps_hsv[COND_SPLIT_NUMBER][6] = {
    // H            S          V
    {340, 360, 36, 100, 22, 100},  // 描述区红
    {0, 10, 36, 100, 45, 100}      // 描述区红
};

void rm_adjoin(cv::Mat &src, int delat_width)
{
  int height = src.rows;
  int width = src.cols;
  int offset = 0; 
  
  int step_width = src.step[0];
  uchar *ptr_mask = src.data;


  for (int i = 0; i < height; i++) {
    int row_sum = 0;  
    for (int j = 0; j < width; j++) {
      if(ptr_mask[offset + j] == 255)row_sum++;
    }
    //cout <<"i :"<<i<<" ;row_sum=: "<< row_sum  <<endl;
    if(row_sum <= delat_width) {
      for (int j = 0; j < width; j++) {
        ptr_mask[offset + j] = 0;
      }
    }

    offset = offset + step_width;
  }
  //imshow("rm_adjoin", src);
}

int check_red_contours(cv::Mat &src, int scan_item_type){
  // 图片压缩
  int height = src.rows/2;
  int width = src.cols/2;
  int offset = 0; 
  Mat img_hsv, img;
  vector<Mat> img_list;

  int size_height,size_width, threshold, char_adjust_minH, char_minH, char_maxH, block_minW, contour_pts_min ;

  // TODO: 先取出红色图案
  Mat img_mask = cv::Mat::zeros(height, width, CV_8UC1);
  uchar *ptr_mask = img_mask.data;
  int step_width = img_mask.step[0];

  #if 0
  img = src;

  size_height = 30;
  size_width = 45;
  if(scan_item_type == VISA_ISSUE_NO_RIGHT_TOP)
    size_width = 60;
  
  cvtColor(src, img_hsv, CV_BGR2HSV);
  split(img_hsv, img_list);  
  uchar *ptr_h = img_list[0].data;
  uchar *ptr_s = img_list[1].data;
  uchar *ptr_v = img_list[2].data;


  int cond_hsv[COND_SPLIT_NUMBER][6];
  // photoshop定义值和opencv值之间的转换
  for (int i = 0; i < COND_SPLIT_NUMBER; i++) {
    cond_hsv[i][0] = ps_hsv[i][0] / 2;
    cond_hsv[i][1] = ps_hsv[i][1] / 2;
    cond_hsv[i][2] = ps_hsv[i][2] * 255 / 100;
    cond_hsv[i][3] = ps_hsv[i][3] * 255 / 100;
    cond_hsv[i][4] = ps_hsv[i][4] * 255 / 100;
    cond_hsv[i][5] = ps_hsv[i][5] * 255 / 100;
  }

  for (int i = 0; i < height; i++) {
    for (int j = 0; j < width; j++) {
      int cur_idx = offset + j;
      for (int hsv = 0; hsv < COND_SPLIT_NUMBER; hsv++) {
        int cond_h_l = cond_hsv[hsv][0],cond_h_h = cond_hsv[hsv][1];
        int cond_s_l = cond_hsv[hsv][2],cond_s_h = cond_hsv[hsv][3];
        int cond_v_l = cond_hsv[hsv][4],cond_v_h = cond_hsv[hsv][5];
        if ((ptr_h[cur_idx] >= cond_h_l && ptr_h[cur_idx] <= cond_h_h) &&
            (ptr_s[cur_idx] >= cond_s_l && ptr_s[cur_idx] <= cond_s_h) &&
            (ptr_v[cur_idx] >= cond_v_l && ptr_v[cur_idx] <= cond_v_h)) {
              ptr_mask[cur_idx] = 255;
              // 命中任何一种颜色即可以退出
              break;
        }
      }
    }
    offset = offset + step_width;
  }
 #else
   /////////////////////////
   // 识别到有效点较多，膨胀不需要那么大，且只关心x轴方向
  size_height = 1;//8;  //15
  if(scan_item_type == VISA_ISSUE_NO_RIGHT_TOP)
    size_width = 25;//50
  else
    size_width = 20;//40
  threshold = 71;//151

  char_adjust_minH = 13;//25;
  char_minH = 10;//20;
  char_maxH = 60;//120;
  block_minW = 75;//150;

  contour_pts_min = 150;//300;


  cv::Mat lab;
  resize(src, img, Size(width, height),cv::INTER_NEAREST);

  cvtColor(img, lab, CV_BGR2Lab);
  split(lab, img_list);  
  adaptiveThreshold(img_list[1], img_mask, 255, CV_ADAPTIVE_THRESH_MEAN_C,
          CV_THRESH_BINARY, threshold,-7);

  #endif 
  //imshow("img_mask", img_mask);
#ifdef VISA_TRACE 
  imshow("lab_a", img_list[1]);
  imshow("lab_a_adap_threshold",img_mask);
  cv::Mat test_color_img = img.clone();
  offset = 0;
  for (int i = 0; i < height; i++) {
    for (int j = 0; j < width; j++) {
      int cur_idx = offset + j;
      if(ptr_mask[cur_idx] == 255){
        circle(test_color_img,Point(j,i),1,Scalar(0,255,0));
      }
    }
    offset = offset + step_width;
  }
  
  g_vis_no_cut = src;
  g_vis_no_color = test_color_img;
  //imshow("test_color_img", test_color_img);
  //waitKey(0);
#endif

  // TODO：判断红色图案结构满足条件
  Mat img_mask_mop_colse;
  Mat element = getStructuringElement(MORPH_RECT, Size(size_width, size_height));
  morphologyEx(img_mask, img_mask_mop_colse, CV_MOP_CLOSE, element);
  
  #ifdef VISA_TRACE 
  imshow("img_mask_mop_colse", img_mask_mop_colse);
  #endif 

  vector<vector<Point>> contours_mask;
  std::vector<cv::Vec4i> hierarchy;
  findContours(img_mask_mop_colse, contours_mask, hierarchy, RETR_EXTERNAL,
               CHAIN_APPROX_NONE);  // CHAIN_APPROX_SIMPLE);
  int contours_cnt = contours_mask.size();
  vector<Rect> candidate_rect_list;
  vector<Rect> ambiguity_rect_list;
  for (int i = 0; i < contours_cnt; i++) { 
    //printf("contours_mask[%d] cnt = %d\n", i, contours_mask[i].size());
    if (contours_mask[i].size() > contour_pts_min) {
      // 参数给的足够大，不需要考虑有效数据被分成多处的情况
      Rect rect = boundingRect(Mat(contours_mask[i]));
      //std::cout << "rect:" << rect << std::endl;
      int rect_w = max(rect.height , rect.width);
      int rect_h = min(rect.height , rect.width);
      double scalar = 1.0 * rect_w / rect_h;
      if ((rect_h >= char_minH ) && (scalar > 3)) {
         candidate_rect_list.push_back(rect);     
         //std::cout << "candidate_rect:" << rect << std::endl;
      } else if(rect_h >=char_maxH && rect_w >= rect_h) {
        ambiguity_rect_list.push_back(rect);
      }
    }
  }
  // 判断是否存在
  int candidate_rect_cnt = candidate_rect_list.size();
  //std::cout << "candidate_rect_cnt:" << candidate_rect_cnt << std::endl;
  if(candidate_rect_cnt == 0) {
    if(ambiguity_rect_list.size() == 0) return -1;
    // 此时考虑争议轮廓，看是否有粘连的情况
    int tmp_width = 0;
    for (int i = 0; i < ambiguity_rect_list.size(); i++) { 
      if(ambiguity_rect_list[i].width > tmp_width)
        tmp_width = ambiguity_rect_list[i].width;
    }
    //std::cout << "ambiguity_rect_list max width:" << tmp_width << std::endl;
    // 宽度太窄也没有特殊处理的必要了
    if(tmp_width < block_minW)
      return -1;

    // 筛选的宽度阈值参考争议轮廓的宽度比例
    rm_adjoin(img_mask_mop_colse, tmp_width/3);
    vector<vector<Point>>().swap( contours_mask);
    std::vector<cv::Vec4i> ().swap(hierarchy);
    findContours(img_mask_mop_colse, contours_mask, hierarchy, RETR_EXTERNAL,
                CHAIN_APPROX_NONE);  // CHAIN_APPROX_SIMPLE);
    contours_cnt = contours_mask.size();
    for (int i = 0; i < contours_cnt; i++) { 
      //printf("contours_mask[%d] cnt = %d\n", i, contours_mask[i].size());
      if (contours_mask[i].size() > contour_pts_min) {
        // 参数给的足够大，不需要考虑有效数据被分成多处的情况
        Rect rect = boundingRect(Mat(contours_mask[i]));
        //std::cout << "rect:" << rect << std::endl;
        int rect_w = max(rect.height , rect.width);
        int rect_h = min(rect.height , rect.width);
        double scalar = 1.0 * rect_w / rect_h;
        if ((rect_h >= char_adjust_minH ) && (scalar > 3)) {
          candidate_rect_list.push_back(rect);     
          //std::cout << "candidate_rect:" << rect << std::endl;
        } 
      }
    }
    candidate_rect_cnt = candidate_rect_list.size();
    //std::cout << "ambiguity candidate_rect_cnt:" << candidate_rect_cnt << std::endl;
    if(candidate_rect_cnt == 0)return -1;
  }
  
  return 0;
}

void get_src_map_point(Point2f pt_src, Point2f* pt_dst, int src_high_offset, float mat_length, Size size)
{
  // 角度计算
  float r = g_get_issue_addr.roi_angle*CV_PI/180.0;

  // 相对roi的位置
  get_roi_map_point( pt_src, pt_dst,  r);
  get_valid_point(pt_dst, size);

  // 相对src的位置
  pt_dst->y += src_high_offset;
  // 默认 签发地的位置 参照 有效数字宽度 来查找
  pt_dst->x += mat_length * sin(r);
  pt_dst->y -= mat_length * cos(r);
  get_valid_point(pt_dst, size);
  //LOGI("pt_dst->x=%f; pt_dst->y=%f.\n", pt_dst->x, pt_dst->y);
}


cv::Mat get_target_image(cv::Mat& src, int src_high_offset, float item_high_top, float item_high_bottom, 
		      Point2f map_char_addr_s, Point2f map_char_addr_e)
{
    double start=tdr_get_current_time(); 
    Size src_size;
    Point2f issue_addr_tl, issue_addr_tr, issue_addr_bl, issue_addr_br;
    float r = g_get_issue_addr.roi_angle*CV_PI/180.0;
  
    src_size.width = src.cols;
    src_size.height = src.rows;
  
    get_src_map_point(map_char_addr_s, &issue_addr_tl, src_high_offset , item_high_top, src_size);
    get_src_map_point(map_char_addr_e, &issue_addr_tr, src_high_offset , item_high_top, src_size);
    get_src_map_point(map_char_addr_s, &issue_addr_bl, src_high_offset , item_high_bottom, src_size);
    get_src_map_point(map_char_addr_e, &issue_addr_br, src_high_offset , item_high_bottom, src_size);

    g_point_list.push_back(issue_addr_bl);
    g_point_list.push_back(issue_addr_tl);
    g_point_list.push_back(issue_addr_tr);
    g_point_list.push_back(issue_addr_br);

    RotatedRect rotatedRect =  minAreaRect(g_point_list);
    Rect rect = rotatedRect.boundingRect();
    /*
#ifdef VISA_TRACE
    LOGD(" rotatedRect.center  = %f; %f; rotatedRect.size=%f; %f; rotatedRect.angle%f; g_get_issue_addr.roi_angle=%f.",  
       rotatedRect.center.x, rotatedRect.center.y,rotatedRect.size.width,rotatedRect.size.height, rotatedRect.angle, g_get_issue_addr.roi_angle);
#endif
  */ 
  
    get_valid_rect(&rect, src_size);
    Mat src_issue_item  = src(rect);
    Mat src_issue_item_rotation;

    if(0)
    { 
      Size s_v;
      s_v.width = rect.width;
      s_v.height = rect.height;
      rotation(src_issue_item, src_issue_item_rotation, s_v, rotatedRect.center-(Point2f)rect.tl(), g_get_issue_addr.roi_angle);
    }
    else
    {
      Mat rot_mat = getRotationMatrix2D(rotatedRect.center-(Point2f)rect.tl(), g_get_issue_addr.roi_angle, 1.0);
      Size s_v;
      Size s_v_new;

      s_v.width = rect.width;
      s_v.height = rect.height;
      float alpha = cos(r);
      float beta = sin(r);

      s_v_new.width = s_v.height*fabs(beta) + s_v.width*fabs(alpha);
      s_v_new.height = s_v.height*fabs(alpha) + s_v.width*fabs(beta);
              
      rot_mat.at<double>(0,2) += (double)(s_v_new.width/2-s_v.width/2);
      rot_mat.at<double>(1,2) += (double)(s_v_new.height/2-s_v.height/2);

      s_v_new.width = round(s_v_new.width);
      s_v_new.height = round(s_v_new.height );
      warpAffine(src_issue_item, src_issue_item_rotation, rot_mat, s_v_new, INTER_LINEAR, BORDER_CONSTANT, Scalar(GRAYCOLOR,GRAYCOLOR,GRAYCOLOR)); 

    }

    double end=tdr_get_current_time();
    LOGD("get_target_image cost %f ms", end-start);

    return src_issue_item_rotation;
}


int check_crnn_extract_en_result(cv::Mat& src, RotatedRect rotated_rect)
{
  Point2f points[4];
  int edge = 0;
  int x_start = edge;
  int y_start = edge;
  int x_end = src.cols - 1 - edge;
  int y_end = src.rows - 1 - edge;

  rotated_rect.points(points);
  sort(&points[0], &points[4], compoint_x);
  if(x_end < 0 || points[0].x <= x_start || points[3].x >= x_end)
    //return ERROR_VISA_EXTRACT_EN_X;
    return -1;

  sort(&points[0], &points[4], compoint_y);
  if(y_end < 0 || points[0].y <= y_start || points[3].y >= y_end)
    //return ERROR_VISA_EXTRACT_EN_Y;
    return -1;

  return 0;
}

int detect_category_box(cv::Mat &src, cv::Mat &dst, Size element_size, int scan_item_type) {

  cv::Mat gray, threshold_img, tmp_img, mask_img;
  // 机读区的字符宽高，算上相邻间距，会大一些。
  int minW = g_aCharWidth;
  int minH = g_aCharHeight;
  int char_min_w = minW*0.6;//0.6;
  int char_min_h = minH*0.6;//0.7;
  int char_max_h = minH*1.5;
  int char_max_w = minW*2.2;

  //std::cout << "minW:" << minW << "char_min_w:" << char_min_w << std::endl;
  //std::cout << "minH:" << minH << "char_min_h:" << char_min_h << std::endl;

  cv::GaussianBlur(src,src,cv::Size(5,5),1,0);
  //cv::blur(rotate_mat,rotate_mat,cv::Size(5,5));
  //cv::medianBlur(rotate_mat,rotate_mat,5);
  #ifdef VISA_TRACE
  if(VISA_ISSUE_CATEGORY_LEFT == scan_item_type)
    g_visa_category_cut_2 = src;
  else
    g_visa_category_cut_1 = src;
  #endif
  // 获取类型字符二值图
  cvtColor(src, gray, CV_BGR2GRAY);
  //imshow("gray",gray);
  adaptiveThreshold(gray, threshold_img, 255, CV_ADAPTIVE_THRESH_MEAN_C,
        CV_THRESH_BINARY_INV, 101, 80);

  // 旧签证，考虑到字符可能压在虚线上，需要先处理掉虚线
  if(VISA_ISSUE_CATEGORY_LEFT == scan_item_type) {
    vector<vector<Point>> crude_contours_mask;
    std::vector<cv::Vec4i> crude_hierarchy;
    Mat crude_img = threshold_img.clone();
    findContours(crude_img, crude_contours_mask, crude_hierarchy, RETR_EXTERNAL,
                CHAIN_APPROX_SIMPLE);  // CHAIN_APPROX_SIMPLE);
    int crude_contours_cnt = crude_contours_mask.size();
    for (int i = 0; i < crude_contours_cnt; i++) { 
      //printf("crude_contours_mask[%d] cnt = %d\n", i, crude_contours_mask[i].size());
      Rect rect = boundingRect(Mat(crude_contours_mask[i]));
      //std::cout << "rect:" << rect << std::endl;

      if(crude_contours_mask[i].size() <=10 && rect.height<=2 && rect.width <=7)
        drawContours(threshold_img, crude_contours_mask, i, Scalar(0),-1);
    }
    //imshow("threshold_filter",threshold_img);  

  }        

  #ifdef VISA_TRACE
  imshow("adaptiveThreshold",threshold_img); 
  #endif  

  // 去掉白线影响，若是两个字符，将其连在一起
  cv::Mat element = getStructuringElement(MORPH_RECT, element_size);
  morphologyEx(threshold_img, tmp_img, CV_MOP_CLOSE, element);
  #ifdef VISA_TRACE
  imshow("morphologyEx",tmp_img);
  #endif
  vector<vector<Point>> contours_mask;
  std::vector<cv::Vec4i> hierarchy;
  findContours(tmp_img, contours_mask, hierarchy, RETR_EXTERNAL,
               CHAIN_APPROX_NONE);  // CHAIN_APPROX_SIMPLE);
             
  int contours_cnt = contours_mask.size();
  vector<Rect> candidate_rect_list;
  //mask_img = Mat::zeros(tmp_img.size(),tmp_img.type());  

  for (int i = 0; i < contours_cnt; i++) { 
    //printf("contours_mask[%d] cnt = %d\n", i, contours_mask[i].size());
    if (contours_mask[i].size() > 20) 
    {
      Rect rect = boundingRect(Mat(contours_mask[i]));
      //std::cout << "rect:" << rect << std::endl;
      int rect_w = rect.width;
      int rect_h = rect.height ;
      double scalar = 1.0 * rect_w / rect_h;
      //std::cout << "scalar:" << scalar << std::endl;
      if ((rect_h >= char_min_h) && (rect_w >= char_min_w)
       && (rect_h < char_max_h) && (rect_w < char_max_w)
       // 考虑到倾斜、扭曲变形，这个参数也必须留有冗余
       && (scalar <=1.45 && scalar >=0.48)) {
         candidate_rect_list.push_back(rect);     
         //std::cout << "candidate_rect:" << rect << std::endl;
         //drawContours(mask_img, contours_mask, i, Scalar(255));
      } 
    }
  }
  //imshow("mask_img",mask_img);

  int candidate_rect_cnt = candidate_rect_list.size();
  Rect roi_rect;
  if(candidate_rect_cnt == 0) return -1;
  else if(candidate_rect_cnt == 1) {
    roi_rect = candidate_rect_list[0];
  }
  else {
    // 判断轮廓条件：高度更接近机读区字符高度？宽高比更合理？更居中
    Point img_center = Point(threshold_img.cols/2,threshold_img.rows/2);
    vector<int> distance_list;
    for(int i=0;i<candidate_rect_cnt;i++){
      Rect rect = candidate_rect_list[i];
      int tmp_x = rect.x + rect.width/2;
      int tmp_y = rect.y + rect.height/2;
      int distance = sqrt(pow(tmp_x-img_center.x, 2) + pow(tmp_y-img_center.y, 2));
      distance_list.push_back(distance);
    }

    int tmp_distance = 0x7FFF;
    int idx = -1;
    for(int i=0;i<candidate_rect_cnt;i++){
      if(distance_list[i]<tmp_distance){
        tmp_distance = distance_list[i];
        idx = i;
      }
    }
    //cout<<"#############################################################----:"<< idx <<endl;
    if(idx != -1)
      roi_rect = candidate_rect_list[idx];
    else
      return -2;
  }
  
  // 压边可能识别错，至少保证不压边
  int side_protect = 0;
  int edge_x = 10;
  int edge_y = 5;
  int delta = edge_x;
  // 扩展时，尽量保持在居中的位置，好识别
  if(roi_rect.x<delta)delta = roi_rect.x;
  int tmp = threshold_img.cols - (roi_rect.x + roi_rect.width);
  if(tmp < side_protect) return -3;
  if(tmp < delta) delta = tmp;
  roi_rect.x -= delta;
  roi_rect.width += delta + delta; 
  //cout<<"x轴方向扩展: "<<delta<<endl;

  delta = edge_y;
  if(roi_rect.y<delta)delta = roi_rect.y;
  tmp = threshold_img.rows - (roi_rect.y + roi_rect.height);
  if(tmp < side_protect) return -3;
  if(tmp < delta) delta = tmp;
  roi_rect.y -= delta;
  roi_rect.height += delta + delta; 
  //cout<<"y轴方向扩展: "<<delta<<endl;
  
  //Mat tmp_dst = threshold_img(roi_rect);
  //cvtColor(tmp_dst, dst, CV_GRAY2BGR);
  dst = src(roi_rect);
  #ifdef VISA_TRACE
  g_visa_category_detect = dst;
  imshow("dst",dst);
  #endif 

  return 0;
}

int get_visa_issue_info(cv::Mat& src, OCR_RESULT &ocr_result)
{
      //double start=tdr_get_current_time();
      int src_high_offset = src.rows-CUT_SIZE-1;
      {
          TextLine text;

          // 判断是否取到可用旋转数据  
          {
            bool rs_im_valid_0 = g_rotated_struct[0].im_valid;
            bool rs_im_valid_1 = g_rotated_struct[1].im_valid;
            
            //cout<<"rs_im_valid_0: "<<rs_im_valid_0;
            //cout<<"rs_im_valid_1: "<<rs_im_valid_1<<endl;

            if(rs_im_valid_0==rs_im_valid_1)
            {
              LOGD("no invertAffineTransform result. ");
              return ERROR_VISA_NO_CONDITION;
	          }
            // 为兼容原来的实现，还是需要g_get_issue_addr
            if(rs_im_valid_0==true)
              g_get_issue_addr = g_rotated_struct[0];
            else
              g_get_issue_addr = g_rotated_struct[1]; 
          }  


          char category_s[4];
          memcpy(category_s, &ocr_result.mrz[0], 2);
          category_s[2]=0x00;
          int icao=ocr_result.icao_type;

          int v_type = -1;
          // TODO 去掉支持类型还剩4种类型          
          for(int i=0; i< SCAN_LOCATION_SIZE; i++){
	           g_point_list.clear();  
             float item_high_top ;
             float item_high_bottom ;
             RotatedRect rotated_rect;
             Point2f map_char_addr_s ;
             Point2f map_char_addr_e ;

             int category=scan_item_location[i][SCAN_ITEM_CATEGORY];
             // 当前版本 仅通过icao就可以区分类型
             if( //(category==VISA_CATEGORY_VX  && (memcmp(category_s, "VX", 2)==0)) ||
                 (category==VISA_CATEGORY_V   && category_s[0]=='V' )//&& category_s[1]!='X')
              )
             {
             }
             else { 
                 continue;
             }
             if(scan_item_location[i][SCAN_ITEM_ICAO]!=icao) {
                    continue;
             }

             int scan_item=scan_item_location[i][SCAN_ITEM_LOC];
             int ITEM_H_MAP_S_CHAR_EXT=scan_item_location[i][SCAN_ITEM_START_Y];
             int FIRST_CHAR_EXT=scan_item_location[i][SCAN_ITEM_BASE_Y];
             int ITEM_H_MAP_E_CHAR_EXT=scan_item_location[i][SCAN_ITEM_END_Y];
             int ITEM_W_S_CHAR_EXT=scan_item_location[i][SCAN_ITEM_START_X]-1;
             int ITEM_W_E_CHAR_EXT=scan_item_location[i][SCAN_ITEM_END_X] - 1;

             item_high_top = g_posRect[ITEM_H_MAP_S_CHAR_EXT].x-g_posRect[FIRST_CHAR_EXT].x; 
             item_high_bottom = g_posRect[ITEM_H_MAP_E_CHAR_EXT].x-g_posRect[FIRST_CHAR_EXT].x;
             map_char_addr_s = Point2f(g_posRect.at(ITEM_W_S_CHAR_EXT).tl());
             map_char_addr_e = Point2f(g_posRect.at(ITEM_W_E_CHAR_EXT).tl());
             map_char_addr_e.x += (map_char_addr_e.x - map_char_addr_s.x )* (scan_item_location[i][SCAN_ITEM_SCALE_X])/100;
             // 国内签发？卡片式？机读区是签证号，内容识别区是护照号
             if(scan_item==VISA_PASSPORT_NO){
               // 将签证号复制给其应该存储的位置
                strcpy(ocr_result.add_id, ocr_result.id);
                continue;
             }

             //取大致位置
	           cv::Mat rotate_mat =  get_target_image(src, src_high_offset, item_high_top, item_high_bottom, map_char_addr_s, map_char_addr_e);
             if(rotate_mat.empty()) continue;
             
            cv::Mat category_box_mat;
            cv::Mat box_mat;

            if( scan_item == VISA_ISSUE_NO_RIGHT_MID || scan_item == VISA_ISSUE_NO_RIGHT_TOP ){  
              #ifdef VISA_TRACE
              imshow("mat_issue_no",rotate_mat);
              #endif
              int ret = check_red_contours(rotate_mat, scan_item);
              if(ret != 0) {
                LOGD("visa issue no check red contour failed. ret=%d. ",ret);
                continue;
              }
            } else {
              double start=tdr_get_current_time();
              // 根据签证号进行签证类型匹配，匹配不成功结束操作。
              if(VISA_ISSUE_NO_RIGHT_MID == v_type) {
                if(scan_item != VISA_ISSUE_CATEGORY_MID)
                  continue;
                else { 
                  int ret = detect_category_box(rotate_mat, category_box_mat, Size(11, 5),scan_item);
                  if(ret != 0) {
                    LOGD("VISA_ISSUE_CATEGORY_MID detect failed. ret=%d. ",ret);
                    return ERROR_VISA_NO_CONDITION;
                  }
                } 
              } else if(VISA_ISSUE_NO_RIGHT_TOP == v_type) {
                if(scan_item != VISA_ISSUE_CATEGORY_LEFT)
                  continue;
                 else {
                  int ret = detect_category_box(rotate_mat, category_box_mat,Size(13, 9),scan_item);
                  if(ret != 0) {
                    LOGD("VISA_ISSUE_CATEGORY_LEFT detect failed. ret=%d. ",ret);
                    return ERROR_VISA_NO_CONDITION;
                  }
                } 
              } else {
                LOGD("no visa type. ");
                return ERROR_VISA_NO_CONDITION;
              }
              double end=tdr_get_current_time();
              LOGD("detect_category_box cost %f ms", end-start);
              //waitKey(0);
            }
             
             
             if( scan_item == VISA_ISSUE_NO_RIGHT_MID || scan_item == VISA_ISSUE_NO_RIGHT_TOP )
             {
                //取文本框
                int minW = scan_item_location[i][SCAN_ITEM_MINW] * g_aCharWidth;
                int minH = scan_item_location[i][SCAN_ITEM_MINH] * g_aCharHeight;
                box_mat = crnn_detect_textbox(rotate_mat, minW, minH, (TEXT_BOX_FILTER_TYPE)scan_item_location[i][SCAN_ITEM_FILTER],(SCAN_LOCATION)scan_item, rotated_rect);
                if(box_mat.empty()) {LOGD("box_mat error.");continue;}

                int extract_result = check_crnn_extract_en_result(rotate_mat, rotated_rect);
                if(0 != extract_result) {
                  LOGD("check_crnn_extract_en_result error = %d", extract_result);
                  continue;
                }
                //识别
                #ifdef USE_VISA_NO
                    //printf("---------USE_VISA_NO---------------\n");
                      cv::GaussianBlur(box_mat,box_mat,cv::Size(3,3),1,0);
                      int scan_result = scanVisaNo(box_mat, text, scan_item);
                      if(0 != scan_result){
                        LOGD("scanVisaNo error = %d. need exe scanVisaNo_Ext.", scan_result);
						            /////////////////////////////////////////
                        // TODO 新版签证2：签证号位置和旧版签证号位置相同，但是9个数字，需要重新识别验证；签证类型位置特殊暂不处理
                        int scan_ext_result = scanVisaNo_Ext(box_mat, text);
                        if(0 != scan_ext_result){
                          LOGD("scanVisaNo_Ext error = %d", scan_result);
                          continue;
                        }
                        bool check_ext_rsp = checkVisaNo_Ext(&text);
                        if(check_ext_rsp){
                          strcpy(ocr_result.add_id, text.text.c_str());
                          // 设置直接结束，不支持类型获取
                          v_type = -1;
                          i = SCAN_LOCATION_SIZE;
                        }
						            ////////////////////////////////////
                        continue;
                      }			 
                #else
                  //printf("---------ERROR_USE_VISA_NO_NO_SUPPORT---------------\n");
                  continue;
                #endif    
                      
             } else if(scan_item == VISA_ISSUE_CATEGORY_LEFT|| scan_item == VISA_ISSUE_CATEGORY_MID) {
               //printf("---------VISA_ISSUE_CATEGORY---------------\n");
              int scan_result = scan_category(category_box_mat, text);
              
               if(0 != scan_result){
                  LOGD("scan_category error = %d", scan_result);
                  continue;
               }		
             }

             //检查结果
             bool check_rsp=checkVisaText(&text, scan_item);
             //printf("---------checkVisaText ret = %d;   can_item=%d-------------\n", check_rsp, scan_item);
             if(check_rsp){
                 if(scan_item == VISA_ISSUE_NO_RIGHT_MID || scan_item == VISA_ISSUE_NO_RIGHT_TOP){
                     strcpy(ocr_result.add_id, text.text.c_str());
                     v_type = scan_item;
                     int value = max(VISA_ISSUE_NO_RIGHT_MID, VISA_ISSUE_NO_RIGHT_TOP);
                     i = value;
                 }
				         // TODO 原来为什么要注释掉？而且应该是给 ocr_result.id赋值
                 //else if(scan_item==VISA_PASSPORT_NO){
                     // strcpy(ocr_result.add_id, text.text.c_str());
                 //}
                 else if(scan_item == VISA_ISSUE_CATEGORY_LEFT|| scan_item == VISA_ISSUE_CATEGORY_MID){
                   strcpy(ocr_result.category, text.text.c_str());
                   int value = max(VISA_ISSUE_CATEGORY_LEFT, VISA_ISSUE_CATEGORY_MID);
                   i = value;
                 }
             } 
          }

          //double end=tdr_get_current_time();
          //LOGD("get_visa_issue_info cost %f ms", end-start);
      } 
  return 0;
}


void  removeSmallAreaContour(IplImage* src, int top);

#if 0
int scanVisaNo(cv::Mat & box_mat, TextLine & text)
{
       cv::Mat boxmat_gray;
       text.text="";
       text.charScores.clear();
       cvtColor(box_mat, boxmat_gray, CV_RGB2GRAY);
       adaptiveThreshold(boxmat_gray, boxmat_gray, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31,17);//31,17
       IplImage iplimg=boxmat_gray;
       removeSmallAreaContour(&iplimg, 20);
       //imshow("box_mat", boxmat_gray);
       vector <Rect> pos;
       bitwise_not(boxmat_gray,boxmat_gray);
       int ret = charseg(boxmat_gray, pos);
       if(ret!=0) return -1;
       //showLineRect(boxmat_gray, pos, "111");
       if(pos.size()!=8) return -1; 

       cv::Mat eng_mat;
       cv::Mat dig_mat;
       cv::Rect rect;
       rect.x=0;
       rect.y=0;
       rect.height=box_mat.rows;
       rect.width=pos[0].x+pos[0].width+3;
       eng_mat=box_mat(rect);

       rect.x=pos[1].x-3;
       rect.y=0;
       rect.height=box_mat.rows;
       rect.width=box_mat.cols - rect.x;
       dig_mat=box_mat(rect);
       //imshow("eng_mat", eng_mat);
       //imshow("dig_mat", dig_mat);
       TextLine text_dig, text_eng;
       text_eng = crnn_extract_en(eng_mat, 'L');
       text_dig = crnn_extract_en(dig_mat, 'N');
       if( text_eng.text.length()!=1 || text_dig.text.length()!=7) return -1;

       int len=text_eng.text.length()+text_dig.text.length(); 
       text.text.resize(len);
       text.charScores.resize(len);
       text.text= text_eng.text + text_dig.text;
       return 0;
}
#endif

int scanVisaNo(cv::Mat & box_mat, TextLine & text, int scan_item)
{
      // 目前看到的测试样本 旧格式是1个字母，新格式是2个字母。且旧格式用O时，首字母I容易识别成1
       if(VISA_ISSUE_NO_RIGHT_TOP == scan_item)
        text =  crnn_extract_en(box_mat, 'A');//'A'); //'A'表示，以一个字母开头，后跟数字
       else 
        text =  crnn_extract_en(box_mat, 'O');//'A'); //'A'表示，以一个字母开头，后跟数字 

       if( text.text.length()!=8) return -1;
       return 0;
}

int scan_category(cv::Mat & box_mat, TextLine & text)
{
      text =  crnn_extract_en(box_mat, 'O'); //'A'表示，以一个字母开头，后跟数字
      //crnn_extract_cn (W) 识别成（W）不能去除（）不满足需求
      //text =  crnn_extract_cn(box_mat);
      if( text.text.length() > 2) return -1;
      return 0;
}

// TODO 新版签证2的签证号长度是9，和其他版本不同【8】，单独处理
int scanVisaNo_Ext(cv::Mat & box_mat, TextLine & text)
{
      text =  crnn_extract_en(box_mat, 'N');// 'O'字母数字 'N'数字
      if( text.text.length()!=9) return -1;
      return 0;
}

#endif
