

#include <opencv2/opencv.hpp>
#include <iostream>
#include "common.h"
#include <omp.h>
#include "tdrocr.h"
#include "utils.h"
#include <stdio.h>
#include "passport_visa.h"
#include "OcrStruct.h" 
#include "tdr_crnn.h"
  
#ifdef SUPPORT_VISA  
extern const char*  wl_num;
extern const char*  wl_2;
extern int g_line1_edge;

//const char visa_category_type_1[]={
  //'C','D','G','Z','F','M','L','R','T','W',
//};

  //TODO 添加Q的异常保护0，会增加非有效数据误识别风险！
  //不建议添加，除非机读区已经确定该字符，并且机读区兼容判断 Q->0的方式！！！
//const char visa_category_type_2[]={
  //'Q','X','S','J', '0'
//};

  //TODO 添加1的异常保护I，会增加非有效数据误识别风险！
  //不建议添加，除非机读区已经确定首字符 是'Q','X','S','J'
  // ！！！有没有‘2’受白线影响，截断，误判成I的可能性？
//const char visa_category_num_2[]={
  //'1','2', 'I'
//};

extern PASSPORT_ROTATED_STRUCT g_rotated_struct[];
extern PASSPORT_ROTATED_STRUCT g_get_issue_addr;
extern vector<Point> g_point_list;
void get_roi_map_point(Point2f pt_src, Point2f* pt_dst, float r);
void get_src_map_point(Point2f pt_src, Point2f* pt_dst, int src_high_offset, float mat_length);

void clearVisaIssueInfo()
{
  for(int i = 0; i<2; i++){
    PASSPORT_ROTATED_STRUCT* rs = &g_rotated_struct[i];
    rs->roi_angle = 0;
    rs->rrect.width = 0;
    rs->rrect.height = 0;
    rs->im_valid = false;
    rs->after_affine_cut_diff= Size(0,0);
    rs->before_affine_cut_diff= Size(0,0);
  }
  g_point_list.clear();
}

void get_valid_point(Point2f* pt, Size size)
{
  if(pt->x < 0) pt->x = 0;
  if(pt->x > size.width - 1) pt->x = size.width -1;
  if(pt->y < 0) pt->y = 0;
  if(pt->y > size.height - 1) pt->y = size.height -1;
}

void get_valid_rect(Rect* rect, Size size)
{
  if(rect->x < 0) rect->x = 0;
  if(rect->x + rect->width > size.width - 1) rect->width = size.width - 1 - rect->x;
  if(rect->y < 0) rect->y = 0;
  if(rect->y + rect->height > size.height - 1) rect->height = size.height - 1 - rect->y;
}

void get_roi_map_point(Point2f pt_src, Point2f* pt_dst, float r)
{
  double data[3] = {1.0, 1.0, 1.0};
  data[0] *= (pt_src.x - g_line1_edge + g_get_issue_addr.after_affine_cut_diff.width); 
  data[1] *= (pt_src.y - g_line1_edge + g_get_issue_addr.after_affine_cut_diff.height); 

  Mat a = cv::Mat(3, 1, CV_64FC1, &data);

  Mat b = g_get_issue_addr.im * a ;
  pt_dst->x = (float)b.at<double>(0,0) ;
  pt_dst->y = (float)b.at<double>(0,1) ;
/*
#ifdef VISA_TRACE
  LOGD("pt_src x ;y=%f; %f. ",pt_src.x, pt_src.y);
  LOGD("bm_image target point =%f; %f. ",pt_dst->x, pt_dst->y);
#endif
*/
  pt_dst->x -= g_get_issue_addr.before_affine_cut_diff.width;
  pt_dst->y -= g_get_issue_addr.before_affine_cut_diff.height;

   
  *pt_dst += g_get_issue_addr.rrect.tl();
  /*
#ifdef VISA_TRACE
  LOGD("g_get_issue_addr.rrect x;y=%f; %f .", g_get_issue_addr.rrect.x, g_get_issue_addr.rrect.y);
  LOGD("roi_image target point =%f; %f. ",pt_dst->x, pt_dst->y);
#endif
*/
}


bool checkVisaText(TextLine *text_line , int flag)
{

  bool check_rsp = true;
  char text_char[100];
  int tmp_cnt = 0;

 char visa_category_type_1[20];

//TODO 添加Q的异常保护0，会增加非有效数据误识别风险！
//不建议添加，除非机读区已经确定该字符，并且机读区兼容判断 Q->0的方式！！！
strcpy(visa_category_type_1, "CDGZFMLRTW");
char visa_category_type_2[20];
strcpy(visa_category_type_2, "QXSJ0");

//TODO 添加1的异常保护I，会增加非有效数据误识别风险！
//不建议添加，除非机读区已经确定首字符 是'Q','X','S','J'
// 有没有‘2’受白线影响，截断，误判成I的可能性？
//TODO 添加2的异常保护Z，
char visa_category_num_2[20];
strcpy(visa_category_num_2, "12IZ");

  
  strcpy(text_char, text_line->text.c_str());
  #ifdef USE_ISSUER_ADDR
  if(VISA_ISSUE_ADDR == flag)
  { 
      int pos_idx;
      //char real_valid_char[100] = {0};
      tmp_cnt = text_line->text.size();
      int k = 0;
      int m =0;

      // 汉字先去掉首尾的字母数字符号.
      for(m = 0; m < tmp_cnt; m ++){
        //LOGD("text_char[m] = %x m=%d.\n", (uchar)text_char[m],m);
        if((uchar)text_char[m] >= 0x80)
          break;
      }
#if 1      
      if(m == tmp_cnt) {
        LOGD("check visa issue addr char type error!");
        check_rsp = false;
      }
      else
      {
        for(k = tmp_cnt - 1; k >= 0; k --){
          //LOGD("text_char[k] = %x k=%d.\n", (uchar)text_char[k],k);
          if((uchar)text_char[k] >= 0x80)
            break;
        }
        //memcpy(real_valid_char, text_char + m, k - m + 1);
        text_line->text = text_line->text.substr(m, k - m +1);
        //LOGD(" text_line->text = %s.\n", text_line->text.c_str());
      }
#else
    if(m != 0) {
      LOGD("check visa issue addr char type error!");
      check_rsp = false;
    }

#endif 
    if(check_rsp) {
      int rsp = check_cityList ((char*)text_line->text.c_str(), &hash_tbl_struct, &pos_idx) ;
      if(0 != rsp) {
        LOGD("check visa issue addr error!  rsp = %d", rsp);
        check_rsp = false;
      }
    }
   
      if(check_rsp)
        LOGD("check visa issue addr ok.");
       
  }
  else 
  #endif 
  if(VISA_ISSUE_NO_RIGHT_MID == flag 
  || flag==VISA_ISSUE_NO_RIGHT_TOP 
  || flag==VISA_PASSPORT_NO)
  {
      #ifdef USE_VISA_NO
      int letter_cnt = 0;
      // 判断个数
      /*
      if(0 == passport_ocr_result.icao_type) {
        tmp_cnt = VISA_NO_CNT;
        letter_cnt = 1;
      } 
      else {
        tmp_cnt = PASSPORT_NO_CNT;
        letter_cnt = 2;
      } 
      */
     bool need_replace = false;
      switch(flag) {
        case VISA_ISSUE_NO_RIGHT_TOP:
          tmp_cnt = VISA_NO_CNT;
          letter_cnt = 1;
          break;
        case VISA_ISSUE_NO_RIGHT_MID:
          tmp_cnt = VISA_NO_CNT;
          letter_cnt = 2;
          // TODO crnn_extract_en使用识别参数O，需要从第3个字符开始做 O->0保护
          // test 故意设置O值
           //text_char[7]='O';
           //text_line->text = text_char;
           //LOGD("replace text_line->text: %s",text_line->text.c_str());
          /////////////////////////////////////////
          for(int k = letter_cnt; k < tmp_cnt; k++){
            if(text_char[k] == 'O') {
              text_char[k]='0';
              need_replace = true;
            }
          }
          if(need_replace) {
            text_line->text = text_char;
            LOGD("replace text_line->text: %s",text_line->text.c_str());
          }
          //////////////////////////
          break;
        case VISA_PASSPORT_NO:
          tmp_cnt = PASSPORT_NO_CNT;
          letter_cnt = 2;
          break;
      }
      
      if(tmp_cnt != text_line->charScores.size()){
        LOGD("check visa no cnt error !");
        check_rsp = false;
      }
      
      if(check_rsp)
      {
        // 判断首字符为字母或是数字 模版中去掉 首字符<
        int tmp_len = strlen(wl_2);
        int k = 0;
        for(int m = 0; m < letter_cnt; m ++){
          for(k = 1; k < tmp_len; k++){
            if(text_char[m] == wl_2[k])
              break;
          }
          if(k == tmp_len){
            LOGD("check visa no first char error !");
            check_rsp = false;
          } 
        }

        if(check_rsp)
        {
          // 判断非首字符为数字 模版中去掉 最后一个字符<
          tmp_len = strlen(wl_num);
          for(int m = letter_cnt; m < tmp_cnt; m ++){
            for(k = 0; k < tmp_len - 1; k++) {
              if(text_char[m] == wl_num[k])
                break;
            }
            if(k == tmp_len - 1){
              LOGD("check visa no non_first char error !");
              check_rsp = false;
              break;
            }   
          }
        }

      } 
      #endif
  } else if(flag==VISA_ISSUE_CATEGORY_LEFT 
  || flag==VISA_ISSUE_CATEGORY_MID) {
    #ifdef USE_VISA_CATEGORY
    // 签证类型是至少一个字母，可能包含数字
    int vale_size = text_line->charScores.size();
    if(1 == vale_size) {
      // 判断是否仅有字母
      int tmp_len = strlen(visa_category_type_1);
      int k = 0;
      for(; k < tmp_len; k++){
        if(text_char[0] == visa_category_type_1[k])
          break;
      }
      if(k == tmp_len){
        LOGD("check visa category first char error ! char=%c. ",text_char[0]);
        check_rsp = false;
      } 
    } else if( 2 == vale_size){
      int tmp_len = strlen(visa_category_type_2);
        int k = 0;
        for(; k < tmp_len; k++){
          if(text_char[0] == visa_category_type_2[k]){
            if(text_char[0]=='0') {
                LOGD("category : %s",text_line->text.c_str());
                text_char[0] = 'Q';
                text_line->text = text_char;
                LOGD("change to : %s",text_line->text.c_str());
              } 
            break;
          }
        }
        if(k == tmp_len){
          LOGD("check visa category first char error !char=%c. ",text_char[0]);
          check_rsp = false;
        }  else {
          int tmp_len = strlen(visa_category_num_2);
          int k = 0;
          for(; k < tmp_len; k++){
            if(text_char[1] == visa_category_num_2[k]){
              if(text_char[1]=='I') {
                LOGD("category : %s",text_line->text.c_str());
                text_char[1] = '1';
                text_line->text = text_char;
                LOGD("change to : %s",text_line->text.c_str());
              } else if(text_char[1]=='Z') {
                LOGD("category : %s",text_line->text.c_str());
                text_char[1] = '2';
                text_line->text = text_char;
                LOGD("change to : %s",text_line->text.c_str());
              }  

              break;
            }
          }
          if(k == tmp_len) {
            LOGD("check visa category non_first char error ! num=%d. ",text_char[1]);
            check_rsp = false;
          }
        }
    } else {
      LOGD("check visa category cnt error ! cnt=%d", vale_size);
      check_rsp = false;
    }
      
    #endif
  }

    //if(!check_rsp) LOGD("check visa error."); 
    return check_rsp;
}

bool checkVisaNo_Ext(TextLine *text_line )
{

  bool check_rsp = true;
  char text_char[100];
  
  strcpy(text_char, text_line->text.c_str());

  #ifdef USE_VISA_NO
  int letter_cnt = 0;
  int tmp_cnt = VISA_NO_EXT_CNT;
  
  if(tmp_cnt != text_line->charScores.size()){
    LOGD("check visa ext no cnt error !");
    check_rsp = false;
  }

  if(check_rsp) {
    int tmp_len = strlen(wl_num);
    for(int m = letter_cnt; m < tmp_cnt; m ++){
      int k;
      for(k = 0; k < tmp_len - 1; k++) {
        if(text_char[m] == wl_num[k])
          break;
      }
      if(k == tmp_len - 1){
        LOGD("check visa no char error !");
        check_rsp = false;
        break;
      }   
    }
  } 
  #endif

  return check_rsp;
}


#if 0
void  check_dispaly(cv::Mat& src, cv::Mat& roi, float r, int flag ) {      
          
  Point2f issue_addr_bl = g_point_list.at(0) ;
  Point2f issue_addr_tl = g_point_list.at(1) ;
  Point2f issue_addr_tr = g_point_list.at(2) ;
  Point2f issue_addr_br = g_point_list.at(3) ;
  // 根据取到的4个点生成矩形，并进行放射变换，截取变换后目标条目数据图
  Mat src_issue_addr = src.clone();
  IplImage tmpImag = IplImage(src_issue_addr);
  cvCircle((CvArr*)&tmpImag, issue_addr_tl ,5, CvScalar(0,0,255),8);
  cvCircle((CvArr*)&tmpImag, issue_addr_tr ,5, CvScalar(255,0,0),8);
  cvCircle((CvArr*)&tmpImag, issue_addr_bl ,5, CvScalar(0,0,255),8);
  cvCircle((CvArr*)&tmpImag, issue_addr_br ,5, CvScalar(255,0,0),8);

  //rectangle(src_issue_addr, rect, CvScalar(0,0,255),3,8,0);
  line(src_issue_addr, issue_addr_tl , issue_addr_tr , CvScalar(0,255,0),3,8,0);
  line(src_issue_addr, issue_addr_tr , issue_addr_br , CvScalar(0,255,0),3,8,0);
  line(src_issue_addr, issue_addr_br , issue_addr_bl , CvScalar(0,255,0),3,8,0);
  line(src_issue_addr, issue_addr_bl , issue_addr_tl , CvScalar(0,255,0),3,8,0);
          
  char title[80];
  sprintf(title, "src_map_%02d", flag);
  cv::imshow(title, src_issue_addr);
  sprintf(title, "output/src_map_%02d.bmp", flag);
  cv::imwrite(title, src_issue_addr);
  //cvSaveImage("output/src_issue_addr1.bmp", &tmpImag, 0);

  int tmp_char_start, tmp_char_end;
  if(flag == FLAG_GET_ISSUE_ADDR)
  {
    if(0 == passport_ocr_result.icao_type)
    {
	    tmp_char_start = PASSPORT_ISSUE_ITEM_W_S_CHAR_EXT;
	    tmp_char_end = PASSPORT_ISSUE_ITEM_W_E_CHAR_EXT;
	  }
    else
    {
	    tmp_char_start = PASSPORT_ISSUE_ITEM_W_S_CHAR_INT;
	    tmp_char_end = PASSPORT_ISSUE_ITEM_W_E_CHAR_INT;
    }
  }
  else 
  {
    if(0 == passport_ocr_result.icao_type)
    {
	    tmp_char_start = PASSPORT_VISA_NUM_ITEM_W_S_CHAR_EXT;
	    tmp_char_end = PASSPORT_VISA_NUM_ITEM_W_E_CHAR_EXT;
    }
    else
    {
	    tmp_char_start = PASSPORT_VISA_NUM_ITEM_W_S_CHAR_INT;
	    tmp_char_end = PASSPORT_VISA_NUM_ITEM_W_E_CHAR_INT;
    }
  }

  Point2f map_char_addr_s = Point2f(g_posRect.at(tmp_char_start - 1).tl());
  get_roi_map_point( map_char_addr_s, &issue_addr_tl,  r);

  Point2f map_char_addr_e = Point2f(g_posRect.at(tmp_char_end - 1).tl());
  get_roi_map_point( map_char_addr_e, &issue_addr_tr,  r);
   
  Mat roi_issue = roi.clone();
  tmpImag = IplImage(roi_issue);
  cvCircle((CvArr*)&tmpImag, issue_addr_tl ,5, CvScalar(0,255,0));
  cvCircle((CvArr*)&tmpImag, issue_addr_tr ,5, CvScalar(255,0,0));//,8);

  if(flag == FLAG_GET_PASSPORT_VISA_NUM)
    {
      Point2f map_char_addr_e_ext = map_char_addr_e;
      Point2f tr_ext;
      // 字符映射不够，最后两个账号需要估算
      if(0 == passport_ocr_result.icao_type)
        map_char_addr_e_ext.x += (map_char_addr_e_ext.x - map_char_addr_s.x )*GET_PASSPORT_VISA_NUM_SCALAR_EXT;
      else
        map_char_addr_e_ext.x += (map_char_addr_e_ext.x - map_char_addr_s.x )*GET_PASSPORT_VISA_NUM_SCALAR_INT;  
      get_roi_map_point( map_char_addr_e_ext, &tr_ext,  r);
      Size src_size;
      src_size.width = roi_issue.cols;
      src_size.height = roi_issue.rows;
       
      get_valid_point(&tr_ext, src_size);
      cvCircle((CvArr*)&tmpImag, tr_ext ,5, CvScalar(0,0,255));
    }
   
   
  sprintf(title, "roi_map_%02d", flag);
  cv::imshow(title, roi_issue);
  sprintf(title, "output/roi_map_%02d.bmp", flag);
  cv::imwrite(title, roi_issue);
  //cvSaveImage("output/src_issue_addr2.bmp", &tmpImag, 0);
}

#endif

#endif
